﻿#NoEnv  ; Recommended for performance and compatibility with future AutoHotkey releases.
; #Warn  ; Enable warnings to assist with detecting common errors.
SendMode Input  ; Recommended for new scripts due to its superior speed and reliability.
SetWorkingDir %A_ScriptDir%  ; Ensures a consistent starting directory.
#NoTrayIcon
#SingleInstance off

ver = 1.2.1
ProgName = GB USB Smart Card save extractor %ver%

Gui, Main:Add, Text, ym+4,GB USB Smart Card save file:
Gui, Main:Add, Edit, xm Section w200 r1 vsav gInputsav
Gui, Main:Add, Button, x+10 ys-1 vSelectsav gSelectsav, ...
Gui, Main:Add, Radio, xs Section Checked vExtract, Extract
Gui, Main:Add, Radio, ys vInject, Inject
Gui, Main:Add, ListBox, xs w230 r11 vListsav gListaction
Gui, Main:+hWndMainGuihWnd
Gui, Main:Show,, %ProgName%
Return

Selectsav:
Gui, Main:+OwnDialogs
sav := DLG_FileOpen(MainGuihWnd, "Sav files (*.sav)",,,, "Select save file", "sav")
;FileSelectFile, sav, 1,, Select save file, Sav files (*.sav)
If sav =
    Return
Else
    GuiControl, Main:, sav, %sav%
Return

Inputsav:
GuiControlGet, sav, Main:, sav
Listsav := "|"
savbin := FileOpen(sav, "r")
savbin.Seek(0x1e000)
game1 := savbin.Read(0xf)
game1l := Asc(savbin.Read(1))
game2 := savbin.Read(0xf)
game2l := Asc(savbin.Read(1))
game3 := savbin.Read(0xf)
game3l := Asc(savbin.Read(1))
game4 := savbin.Read(0xf)
game4l := Asc(savbin.Read(1))
game5 := savbin.Read(0xf)
game5l := Asc(savbin.Read(1))
game6 := savbin.Read(0xf)
game6l := Asc(savbin.Read(1))
game7 := savbin.Read(0xf)
game7l := Asc(savbin.Read(1))
game8 := savbin.Read(0xf)
game8l := Asc(savbin.Read(1))
game9 := savbin.Read(0xf)
game9l := Asc(savbin.Read(1))
game10 := savbin.Read(0xf)
game10l := Asc(savbin.Read(1))
game11 := savbin.Read(0xf)
game11l := Asc(savbin.Read(1))

savbin.Seek(0x8000, 0)
Loop, 11
    {
    If game%A_Index%l != 0
        Listsav .= game%A_Index% "|"
    
    savbin.RawRead(game%A_Index%sav, 0x2000 * game%A_Index%l)
    }
GuiControl, Main:, Listsav, %Listsav%
savbin.Close()
Return

Listaction:
If A_GuiEvent != DoubleClick
    Return
GuiControlGet, Extract, Main:, Extract
GuiControlGet, Inject, Main:, Inject
GuiControlGet, osavname, Main:, Listsav
If Extract = 1
{
Gui, Main:+OwnDialogs
;FileSelectFile, osav, S16, %osavname%.sav, Save sav file, Sav files (*.sav)
osav := DLG_FileSave(MainGuihWnd, "Save files (*.sav)",,, osavname, "Save sav file", "sav")
GuiControlGet, osavname, Main:, Listsav ;for some reason DLG_FileSave overwrites osavname, so lets retrieve it again to restore it.
If osav =
    Return
;SplitPath, osav,,, osavext
;If osavext =
;    osav .= ".sav"
Loop, 11
    {
    If game%A_Index% = %osavname%
        {
        osavnum := A_Index
        Break
        }
    }
osavbin := FileOpen(osav, "w")
osavbin.RawWrite(game%osavnum%sav, 0x2000 * game%osavnum%l)
osavbin.Close()
MsgBox, Done
}

If Inject = 1
{
isav := DLG_FileOpen(MainGuihWnd, "Sav files (*.sav)",,,, "Select save file", "sav")
If isav =
    Return
FileGetSize, isavsize, %isav%
Loop, 11
    {
    If game%A_Index% = %osavname%
        {
        isavnum := A_Index
        Break
        }
    }
If (isavsize != 0x2000 * game%isavnum%l)
    {
    MsgBox, 36,, The size of the saves differ.`n`nContinue anyway?
    IfMsgBox, No
        Return
    }
isavbin := FileOpen(isav, "r")
isavbin.RawRead(isavdata, 0x2000 * game%isavnum%l)
isavbin.Close()
savbin := FileOpen(sav, "a")
savbin.Seek(0x6000 + (0x2000 * isavnum), 0)
savbin.RawWrite(isavdata, 0x2000 * game%isavnum%l)
savbin.Close()
MsgBox, Done
}
Return

MainGuiClose:
ExitApp

#Include DLG_FileOpenSave.ahk